#ifndef _PARSENUMBERS_C
#define _PARSENUMBERS_C

#include <string.h>
#include "xmalloc.h"

// utility function: parse floats from a text file
// returns a pointer to a malloc'ed array of the parsed floats
// fills *no with the number of floats
inline static float *read_ascii_floats(FILE *f, int *no);

// utility function: parse doubles from a text file
// returns a pointer to a malloc'ed array of the parsed doubles
// fills *no with the number of doubles
inline static double *read_ascii_doubles(FILE *f, int *no);

inline
static double *read_ascii_doubles_fn(const char *fname, int *no);

inline
static int parse_doubles(double *t, int nmax, const char *s);


int parse_floats(float *t, int nmax, const char *s);

inline
static float *alloc_parse_floats2(int nmax, const char *s, int *n);

inline
static float *alloc_parse_floats(int nmax, const char *ss, int *n);

inline
static double *alloc_parse_doubles(int nmax, const char *ss, int *n);

// Obtain n numbers from string.
// The string contains a list of ascii numbers
// or the name of a file containing a list of ascii numbers.
// In case of failure, unread numbers are set to zero.
// Returns the number of read numbers.
inline
static int read_n_doubles_from_string(double *out, char *string, int n);

#endif//_PARSENUMBERS_C
