#ifndef UPSA_C
#define UPSA_C

// #include <assert.h>
// #include <ctype.h>
// #include <math.h>
// #include <stdarg.h>
// #include <stdio.h>
// #include <stdlib.h>
// #include <string.h>
// #include <stdbool.h>

// // #include "iio.h"
// #include "fail.h"
// #include "marching_squares.h"
// #include "marching_interpolation.h"
// #include "bicubic.h"

float getsample(float *x, int w, int h, int pd, int i, int j, int l);

void setsample(float *x, int w, int h, int pd, int i, int j, int l,
		float v);

float interpolate_nearest(float a, float b, float c, float d,
					float x, float y);

float interpolate_bilinear(float a, float b, float c, float d,
					float x, float y);

float fade(float x);

float fadeinv(float x);

float interpolate_bilinear_fadeinv(float a, float b, float c, float d,
					float x, float y);

float interpolate_bilinear_fade(float a, float b, float c, float d,
					float x, float y);

float interpolate_cell(float a, float b, float c, float d,
					float x, float y, int method);

void interpolate_vec(float *out, float *x, int w, int h, int pd,
		float p, float q, int m);

float *zoom(float *x, int w, int h, int pd, int n, int zt,
		int *ow, int *oh);

float *zoom_with_offset(float *x, int w, int h, int pd, int n, int zt,
		int *ow, int *oh, float dx, float dy);
#endif
